<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Formatting for log records."><meta name="keywords" content="rust, rustlang, rust-lang, fmt"><title>env_logger::fmt - Rust</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="shortcut icon" href="https:&#x2F;&#x2F;www.rust-lang.org&#x2F;static&#x2F;images&#x2F;favicon.ico"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc mod"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../env_logger/index.html'><div class='logo-container rust-logo'><img src='https:&#x2F;&#x2F;www.rust-lang.org&#x2F;logos&#x2F;rust-logo-128x128-blk-v2.png' alt='logo'></div></a><h2 class="location">Module fmt</h2><div class="sidebar-elems"><div class="block items"><ul><li><a href="#structs">Structs</a></li><li><a href="#enums">Enums</a></li></ul></div><div id="sidebar-vars" data-name="fmt" data-ty="mod" data-relpath="./"></div><script defer src="./sidebar-items.js"></script></div></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><h1 class="fqn"><span class="in-band">Module <a href="../index.html">env_logger</a>::<wbr><a class="mod" href="#">fmt</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span><span class="out-of-band"><span id="render-detail"><a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span><a class="srclink" href="../../src/env_logger/fmt/mod.rs.html#1-652" title="goto source code">[src]</a></span></h1><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>Formatting for log records.</p>
<p>This module contains a <a href="struct.Formatter.html"><code>Formatter</code></a> that can be used to format log records
into without needing temporary allocations. Usually you won’t need to worry
about the contents of this module and can use the <code>Formatter</code> like an ordinary
<a href="https://doc.rust-lang.org/stable/std/io/trait.Write.html"><code>Write</code></a>.</p>
<h1 id="formatting-log-records" class="section-header"><a href="#formatting-log-records">Formatting log records</a></h1>
<p>The format used to print log records can be customised using the <a href="../struct.Builder.html#method.format"><code>Builder::format</code></a>
method.
Custom formats can apply different color and weight to printed values using
<a href="struct.Style.html"><code>Style</code></a> builders.</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">use</span> <span class="ident">std::io::Write</span>;

<span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">builder</span> <span class="op">=</span> <span class="ident">env_logger::Builder::new</span>();

<span class="ident">builder</span>.<span class="ident">format</span>(<span class="op">|</span><span class="ident">buf</span>, <span class="ident">record</span><span class="op">|</span> {
    <span class="macro">writeln!</span>(<span class="ident">buf</span>, <span class="string">&quot;{}: {}&quot;</span>,
        <span class="ident">record</span>.<span class="ident">level</span>(),
        <span class="ident">record</span>.<span class="ident">args</span>())
});</code></pre></div>
</div></details><h2 id="structs" class="section-header"><a href="#structs">Structs</a></h2>
<div class="item-table"><div class="item-left module-item"><a class="struct" href="struct.Formatter.html" title="env_logger::fmt::Formatter struct">Formatter</a></div><div class="item-right docblock-short"><p>A formatter to write logs into.</p>
</div><div class="item-left module-item"><a class="struct" href="struct.Style.html" title="env_logger::fmt::Style struct">Style</a></div><div class="item-right docblock-short"><p>A set of styles to apply to the terminal output.</p>
</div><div class="item-left module-item"><a class="struct" href="struct.StyledValue.html" title="env_logger::fmt::StyledValue struct">StyledValue</a></div><div class="item-right docblock-short"><p>A value that can be printed using the given styles.</p>
</div><div class="item-left module-item"><a class="struct" href="struct.Timestamp.html" title="env_logger::fmt::Timestamp struct">Timestamp</a></div><div class="item-right docblock-short"><p>An <a href="https://www.ietf.org/rfc/rfc3339.txt">RFC3339</a> formatted timestamp.</p>
</div></div><h2 id="enums" class="section-header"><a href="#enums">Enums</a></h2>
<div class="item-table"><div class="item-left module-item"><a class="enum" href="enum.Color.html" title="env_logger::fmt::Color enum">Color</a></div><div class="item-right docblock-short"><p>The set of available colors for the terminal foreground/background.</p>
</div><div class="item-left module-item"><a class="enum" href="enum.Target.html" title="env_logger::fmt::Target enum">Target</a></div><div class="item-right docblock-short"><p>Log target, either <code>stdout</code>, <code>stderr</code> or a custom pipe.</p>
</div><div class="item-left module-item"><a class="enum" href="enum.TimestampPrecision.html" title="env_logger::fmt::TimestampPrecision enum">TimestampPrecision</a></div><div class="item-right docblock-short"><p>Formatting precision of timestamps.</p>
</div><div class="item-left module-item"><a class="enum" href="enum.WriteStyle.html" title="env_logger::fmt::WriteStyle enum">WriteStyle</a></div><div class="item-right docblock-short"><p>Whether or not to print styles to the target.</p>
</div></div></section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="env_logger" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script>
</body></html>